var request = require('./request.js')

module.exports = {

  querySignSummary(teacherId, classId) {
    var params = {
      teacherId: teacherId,
      classId: classId
    }

    return request.get('/preschool/wxsite/teacher/querySignSummary.do', params)
  },
  // 获取所有学生
  getAllStudent(classId) {
    var params = {
      classId: classId
    }
    return request.get('/preschool/wxsite/teacher/getAllStudent.do', params)
  },
  // 签到接口
  signIn(teacherId, classId, studentIds) {
    var params = {
      teacherId: teacherId,
      classId: classId,
      studentIds: studentIds
    }
    return request.post('/preschool/wxsite/teacher/signin.do', params)
  },


  //根据签到表Id获取记录明细
  getRecordDetailForSignId(signSummaryId) {
    var params = {
      signSummaryId: signSummaryId
    }
    return request.get('/preschool/wxsite/teacher/getRecordDetailForSignId.do', params)
  },

  //根据记录类型查询记录流水, 在记录的时候是否需要先查询下当天的之前的记录
  queryRecordList(recordCategory, recordType, signSummaryIds) {
    var params = {
      recordCategory: recordCategory,
      recordType: recordType,
      signSummaryIds: signSummaryIds
    }
    return request.post('/preschool/wxsite/teacher/queryRecordList.do', params)
  },

  //审核签到汇总表
  auditSignSummary(signSummaryId) {
    return request.post('/preschool/wxsite/teacher/auditSignSummary.do?signSummaryId=' + signSummaryId)
  },
}