// pages/add_record/index.js

const req = require('../../api/teacher.js')
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    radioValues: [{
        'value': '饮食',
        'code': 'diet',
        'selected': true
      },
      {
        'value': '睡觉',
        'code': 'sleep',
        'selected': false
      },
      {
        'value': 'WC',
        'code': 'wc',
        'selected': false
      },
    ],
    clazz: [],
    studentIds:[],
    controlIndex: 0,
    categoryCode: ['diet_morning', 'diet_afternoon', 'diet_evening', 'diet_morning_more', 'diet_afternoon_more', 'diet_water', 'diet_milk'],
    categorys: [],
    typeIndex: 0,
    inputModel: [

    ],
    selectPic: [],
    recordTypes: app.globalData.recordTypes,
    eatCellTags: {},

    //获取到的数据
    eatRecord:[],
    sleepRecord:[],
    wcRecord:[]


  },
  //添加图片
  addPicture: function(e) {
    var that = this;
    // 选择图片
    wx.chooseImage({
      sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
      sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
      success: function(res) {
        // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
        for (var i in res.tempFilePaths) {
          that.data.selectPic.push(res.tempFilePaths[i])
        }
        that.setData({
          selectPic: that.data.selectPic
        });
      }
    })
  },

  previewPic: function(e) {
    var current = this.data.selectPic[e.target.dataset.index]
    wx.previewImage({
      current: current,
      urls: this.data.selectPic
    })

  },
  //删除图片
  deleteImg: function(e) {
    var that = this
    that.data.selectPic.splice(e.currentTarget.dataset.index, 1)
    that.setData({
      selectPic: that.data.selectPic
    })
  },
  //选择小分类
  tapType: function(e) {

    this.setData({
      typeIndex: e.target.dataset.index,
    })

    this.getRecord()
  },

  indexChanged: function(e) {
    // 点中的是组中第个元素
    var index = e.target.dataset.index;

    // 读取原始的数组
    var radioValues = this.data.radioValues;
    for (var i = 0; i < radioValues.length; i++) {
      // 全部改为非选中
      radioValues[i].selected = false;
      // 当前那个改为选中
      radioValues[index].selected = true;
    }

    // console.log(radioValues)
    // 写回数据
    this.setData({
      radioValues: radioValues,
      controlIndex: index
    });
    // clazz状态
    this.clazzStatus();

    this.getRecord()
  },

  // 初始化分类数据
  configCategory: function() {
    var categorys = this.data.categorys
    for (var i = 0; i < this.data.categoryCode.length; i++) {
      let category = this.data.recordTypes[this.data.categoryCode[i]]
      categorys.push(category)
    }

    this.setData({
      categorys: categorys
    })
  },

  getRecord: function() {
    let studentIds = this.data.studentIds
    console.log(studentIds)
    
    let category = this.data.radioValues[this.data.controlIndex].code
    let type = ''
    if(this.data.controlIndex == 0) {
      type = this.data.categoryCode[this.data.typeIndex]
    }

    req.queryRecordList(category, type, studentIds).then(res => {
      console.log(res)
      var eatCellTags = this.data.eatCellTags
      var optionTag = ['diet_morning', 'diet_afternoon', 'diet_evening', 'diet_morning_more', 'diet_afternoon_more']
      for (var i = 0; i < res.length; i++) {
        var item = res[i]

        if (item.recordItems.length == 0) {
          //没有记录时, 自动生成一条
          var r = {}
          r.recordType = type
          r.recordCategory = category
          item.recordItems.push(r)
        }

        for (var k = 0; k < item.recordItems.length; k++) {
          var r = item.recordItems[k]
          if (r.recordCategory == 'sleep') {
            r.cellType = 'input'
            r.cellUnit = '分钟'
            break
          }

          if (r.recordCategory == 'wc') {
            r.cellType = 'select'
            r.cellOptions = ['pee', 'poo', 'diaper']
            break
          }

          if (r.recordType == 'diet_milk') {
            r.cellType = 'input'
            r.cellUnit = '毫升'
            break
          }
          if (r.recordType == 'diet_water') {
            r.cellType = 'input'
            r.cellUnit = '次'
            break
          }
          for (var j = 0, len = optionTag.length; j < len; j++) {
            var tag = optionTag[j]
            if (r.recordType == tag) {
              r.cellType = 'select'
              r.cellOptions = ['少', '正常', '多']
              break
            }
          }

        }
      }
      if (this.data.controlIndex == 0) {
        this.setData({
          eatRecord: res
        })
      } else if (this.data.controlIndex == 1) {
        this.setData({
          sleepRecord: res
        })
      } else if (this.data.controlIndex == 2) {
        this.setData({
          wcRecord: res
        })
      }
      
    })
  },

  quantityCellTap: function (e) {
    console.log(e.currentTarget.dataset.optionindex)
    let records 
    if (this.data.controlIndex == 0) {
      records = this.data.eatRecord
    } else if (this.data.controlIndex == 1) {
      records = this.data.sleepRecord
    } else if (this.data.controlIndex == 2) {
      records = this.data.wcRecord
    }

    for (var i = 0; i < records.length; i++) {
      var item = records[i].recordItems[0]
      item.optionIndex = e.currentTarget.dataset.optionindex
    }

    if (this.data.controlIndex == 0) {
      this.setData({
        eatRecord: records
      })
    } else if (this.data.controlIndex == 1) {
      this.setData({
        sleepRecord: records
      })
    } else if (this.data.controlIndex == 2) {
      this.setData({
        wcRecord: records
      })
    }

  },

  onLoad: function(options) {
    this.data.studentIds = JSON.parse(options.studentIds)
    console.log(this.data.studentIds)
    // onLoad 比 onReady 更早调用，后者为选中时屏幕闪动一下
    this.clazzStatus();

    //分类数据
    this.configCategory()
    //获取选中的分类的记录
    this.getRecord()



  },
  clazzStatus: function() {
    /* 此方法分别被加载时调用，点击某段时调用 */
    // class样式表如"selected last","selected"
    var clazz = [];
    // 参照数据源
    var radioValues = this.data.radioValues;
    for (var i = 0; i < radioValues.length; i++) {
      // 默认为空串，即普通按钮
      var cls = '';
      // 高亮，追回selected
      if (radioValues[i].selected) {
        cls += 'selected ';
      }
      // 最后个元素, 追加last
      if (i == radioValues.length - 1) {
        cls += 'last ';
      }
      //去掉尾部空格
      cls = cls.replace(/(\s*$)/g, '');
      clazz[i] = cls;
    }

    // console.log(clazz)
    // 写回数据
    this.setData({
      clazz: clazz
    });
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function() {

  }
})